// ==== Sections coniques ====

// Animations: clock varie toujours de 0  1
#declare cameraFixe = true;
// cameraFixe = true ---> la vue de gauche
// cameraFixe = false ---> la vue de droite
#declare noScene = 1;
// noScene =1 ---> le plan de coupe descend 
// noScene =2 ---> le plan de coupe tourne
// noScene =3 ---> le plan de coupe se dplace vers la gauche

background {color rgb <0.4, 0.4, 1>}

#declare grandNb = 30000;
#declare coneH = grandNb;
#declare coneR = coneH*0.5;
#declare planHinit = 30;
#declare planHfinal = -10;
#declare posDroiteInit = 5;
#declare posDroiteFinal = -5;
#declare largeur = 20;
#declare posCam = 3*<-10,10,-10>;
#declare deltaCam = 50;

#if (noScene = 1)
	#declare versBas = planHinit + clock*(planHfinal-planHinit);
	#declare angleR = 0;
	#declare versDroite = posDroiteInit;
	#declare posCam = <0,deltaCam+versBas,0>;
	#declare pointVise = <0,-grandNb,0>;
#end
#if (noScene = 2)
	#declare versBas = planHfinal;
	#declare angleR = 90*clock;
	#declare versDroite = posDroiteInit;
	#declare posCam = <0,deltaCam+versBas,0>+clock*(<-deltaCam,-deltaCam-versBas,0>);
	#declare pointVise = <0,versBas,0>+clock*(<posDroiteInit,-versBas,0>);
#end
#if (noScene = 3)
	#declare versBas = planHfinal;
	#declare angleR = 90;
	#declare versDroite = posDroiteInit + clock*(posDroiteFinal-posDroiteInit);
	#declare posCam = <-deltaCam,0,0>;
	#declare pointVise = <posDroiteInit,0,0>;
#end

#if (cameraFixe)
	#declare posCam = 3*<-10,10,-10>;
	#declare pointVise = <0,0,0>;
#end

#declare coneHaut = cone { <0, 0, 0>, 0.0, <0, coneH, 0>, coneR  }
#declare coneBas  = cone { <0, 0, 0>, 0.0, <0, -coneH, 0>, coneR }
#declare coneC = union { object {coneHaut} object {coneBas} }
#declare planCoupe = object { 
	plane { <0,1,0>, 0 }
	rotate <0,0,angleR>
	translate <0,versBas,0>
	translate <versDroite,0,0>
}
#declare planCoupeOpp = object { 
	plane { <0,-1,0>, 0 }
	rotate <0,0,angleR>
	translate <0,versBas,0>
	translate <versDroite,0,0>
}
#declare rectangleCoupe = object {
	box { <grandNb, 0, largeur>, <-grandNb, 0, -largeur> }
	rotate <0,0,angleR>
	translate <0,versBas,0>
	translate <versDroite,0,0>
}
#declare coneVisible = intersection { object{coneC} object{planCoupe} }
#declare coneTransparent = intersection { object{coneC} object{planCoupeOpp} }
#declare planApparent = difference { object{rectangleCoupe} object{coneC} }
#declare section = intersection { object{planCoupe} object{planCoupeOpp} object{coneC} }

#declare textureCone = texture { pigment {color rgbt <1, 1, 1, 0>}
  								 normal { bumps 0.3 }
  								 finish { ambient 0.3 specular 0.6 }
 							   }
#if (cameraFixe)
	object { coneVisible texture { textureCone } }
	object { coneTransparent pigment {color rgbt <1, 1, 1, 0.8>} }
	object { planApparent pigment {color rgbt <0, 1, 0, 0.2>} }
#else
	object { section pigment {color rgbt <1, 1, 1, 0>} }
#end

camera {
  location posCam
  look_at pointVise
  right     x*image_width/image_height  
}

light_source {
  posCam
  color rgb <1,1,1>
}

